<img align="left" src="doc/images/jackdaw-logo.png" width=125/>

Jackdaw is a Clojure library for the Apache Kafka distributed streaming platform. With Jackdaw you can create or list topics using the AdminClient API, produce or consume records using the Producer and Consumer APIs, and create stream processing applications using the Streams API. Jackdaw also contains functions to serialize and deserialize records as JSON, EDN, and Avro, as well as functions for writing unit and integration tests.


## Installation

To use the latest release, add the following to your project:

    [fundingcircle/jackdaw "0.4.0"]


## Documentation

- [API docs](https://fundingcircle.github.io/jackdaw/codox/index.html)


## Tutorials

- [Pipe](https://github.com/FundingCircle/jackdaw/tree/master/tutorials/pipe)
- [Word Count](https://github.com/FundingCircle/jackdaw/tree/master/tutorials/word-count)
- [Simple Ledger](https://github.com/FundingCircle/jackdaw/tree/master/tutorials/simple-ledger)


## Community

<img src="doc/images/slack-icon.png" width="30px"> any questions or feedback
to [`#jackdaw`](https://clojurians.slack.com/messages/CEA3C7UG0/)
(or [open an issue](https://github.com/fundingcircle/jackdaw/issues)).


## License

Copyright © 2017 Funding Circle

Distributed under the BSD 3-Clause License.
